#!/usr/bin/python
# index.py by David Blume, extended by Stefan Macke (http://blog.stefan-macke.com)
# This script reads foxmarks.json files and prints links out.

import urllib
import simplejson # http://www.undefined.org/python/
import types
from mod_python import apache

urls = ( ('My Bookmarks', r'ftp://user:pass@server/foxmarks.json'), )

def do_insert(folders, command, req):
    if 'nid' in command:
        args = command['args']
        if args.has_key('ntype'):
            if args['ntype'] == 'folder':
                my_folder = []
                folders[command['nid']] = my_folder
                if command['nid'] != 'ROOT':
                    parent = folders[args['pnid']]
                    parent.append((args['name'], my_folder))
            elif args['ntype'] == 'separator':
                parent = folders[args['pnid']]
                parent.append('---')
            else: # 'bookmark'
                name = args['url'].replace('&', '&amp;')
                if args.has_key('name'):
                    name = args['name'].replace('&', '&amp;')
                parent = folders[args['pnid']]
                parent.append('<li><a href="%s">%s</a></li>\n' % (args['url'].replace('&', '&amp;'), name))

def print_folders(folders, indent, req):
    for item in folders:
        indentStr = '\t' * indent
        indentStr2 = '\t' * (indent + 1)
        if type(item) == types.ListType or type(item) == types.TupleType:
            req.write('%s<li>%s\n%s<ul>\n' % (indentStr, item[0].encode('utf-8', 'replace'), indentStr2))
            print_folders(item[1], indent + 1, req)
            req.write('%s</ul>\n%s</li>%s\n' % (indentStr2, indentStr, '<!-- ' + item[0].encode('utf-8', 'replace') + ' -->'))
        else:
            req.write('%s%s\n' % (indentStr, item.encode('utf-8', 'replace')))

def handler(req):
    req.content_type = "text/html"
    req.write('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">')
    req.write('<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">\n')
    req.write('<head>\n')
    req.write('\t<meta http-equiv="Content-Type" content="text/html;charset=UTF-8" />\n')
    req.write('\t<title>Stefans Bookmarks</title>\n')
    req.write('</head>\n\n')
    req.write('<body>\n')
    for url in urls:
        req.write('<h2>%s</h2>\n' % url[0])
        req.write('<ul>\n')
        sock = urllib.urlopen(url[1])
        json = simplejson.load(sock)
        sock.close()
        folders = {}
        for command in json[u'commands']:
            do_insert(folders, command, req)
        print_folders(folders['ROOT'], 0, req)
        req.write('</ul>\n')
    req.write('</body>\n')
    req.write('</html>\n')
    return apache.OK
